[m4/ChangeLog]
[coreutils.git] / Makefile.maint
blob528c4e70fd913f1eb07277e6119391892532cc6c
1 # -*-Makefile-*-
2 # This Makefile fragment is shared between the coreutils,
3 # CPPI, Bison, and Autoconf.
5 ## Copyright (C) 2001-2006 Free Software Foundation, Inc.
6 ##
7 ## This program is free software; you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation; either version 2, or (at your option)
10 ## any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program; if not, write to the Free Software
19 ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20 ## 02110-1301, USA.
22 # This is reported not to work with make-3.79.1
23 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 ME := Makefile.maint
26 # Do not save the original name or timestamp in the .tar.gz file.
27 # Use --rsyncable if available.
28 gzip_rsyncable := \
29   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
30 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
32 CVS = cvs
34 CVS_LIST = build-aux/vc-list-files
36 CVS_LIST_EXCEPT = \
37   $(CVS_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
39 ifeq ($(origin prev_version_file), undefined)
40   prev_version_file = .prev-version
41 endif
43 PREV_VERSION := $(shell cat $(prev_version_file))
44 VERSION_REGEXP = $(subst .,\.,$(VERSION))
46 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
47 tag-this-version = $(subst .,_,$(VERSION))
48 this-cvs-tag = $(tag-package)-$(tag-this-version)
49 my_distdir = $(PACKAGE)-$(VERSION)
51 # Old releases are stored here.
52 # Used for diffs and xdeltas.
53 release_archive_dir ?= ../release
55 # Prevent programs like 'sort' from considering distinct strings to be equal.
56 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
57 export LC_ALL = C
61 ## --------------- ##
62 ## Sanity checks.  ##
63 ## --------------- ##
65 # FIXME: add a check to prohibit definition in src/*.c of symbols defined
66 # in system.h.  E.g. today I removed from tail.c a useless definition of
67 # ENOSYS.  It was useless because system.h ensures it's defined.
69 # Checks that don't require cvs.
70 # Run `changelog-check' last, as previous test may reveal problems requiring
71 # new ChangeLog entries.
72 local-checks-available = \
73   po-check copyright-check writable-files m4-check author_mark_check \
74   changelog-check patch-check strftime-check $(syntax-check-rules) \
75   makefile_path_separator_check \
76   makefile-check check-AUTHORS
77 .PHONY: $(local-checks-available)
79 local-check = $(filter-out $(local-checks-to-skip), $(local-checks-available))
81 # Collect the names of rules starting with `sc_'.
82 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(ME))
83 .PHONY: $(syntax-check-rules)
85 syntax-check: $(syntax-check-rules)
86 #       @grep -nE '#  *include <(limits|std(def|arg|bool))\.h>'         \
87 #           $$(find -type f -name '*.[chly]') &&                        \
88 #         { echo '$(ME): found conditional include' 1>&2;               \
89 #           exit 1; } || :
91 #       grep -nE '^#  *include <(string|stdlib)\.h>'                    \
92 #           $(srcdir)/{lib,src}/*.[chy] &&                              \
93 #         { echo '$(ME): FIXME' 1>&2;                                   \
94 #           exit 1; } || :
95 # FIXME: don't allow `#include .strings\.h' anywhere
97 sc_cast_of_argument_to_free:
98         @grep -nE '\<free \(\(' $(srcdir)/{lib,src}/*.[chly] &&         \
99           { echo '$(ME): don'\''t cast free argument' 1>&2;             \
100             exit 1; } || :
102 sc_cast_of_x_alloc_return_value:
103         @grep -nE --exclude=$(srcdir)/lib/regex.c                       \
104             '\*\) *x(m|c|re)alloc\>'                                    \
105             $(srcdir)/{lib,src}/*.[chy] &&                              \
106           { echo '$(ME): don'\''t cast x*alloc return value' 1>&2;      \
107             exit 1; } || :
109 sc_cast_of_alloca_return_value:
110         @grep -nE '\*\) *alloca\>'                                      \
111             $(srcdir)/src/*.[chy] &&                                    \
112           { echo '$(ME): don'\''t cast alloca return value' 1>&2;       \
113             exit 1; } || :
115 sc_space_tab:
116         @grep -n '[ ]   ' $$($(CVS_LIST_EXCEPT)) &&                     \
117           { echo '$(ME): found SPACE-TAB sequence; remove the SPACE'    \
118                 1>&2; exit 1; } || :
120 # Don't use the old ato* functions in `real' code.
121 # They provide no error checking mechanism.
122 # Instead, use strto* functions.
123 sc_prohibit_atoi_atof:
124         @grep -nE '\<ato([filq]|ll)\>' $$($(CVS_LIST_EXCEPT)) &&        \
125           { echo '$(ME): do not use ato''f, ato''i, ato''l, ato''ll, or ato''q' \
126                 1>&2; exit 1; } || :
128 # Using EXIT_SUCCESS as the first argument to error is misleading,
129 # since when that parameter is 0, error does not exit.  Use `0' instead.
130 sc_error_exit_success:
131         @grep -nF 'error (EXIT_SUCCESS,'                                        \
132             $$(find -type f -name '*.[chly]') &&                        \
133           { echo '$(ME): found error (EXIT_SUCCESS' 1>&2;               \
134             exit 1; } || :
136 sc_file_system:
137         @grep -ni 'file''system' $$($(CVS_LIST_EXCEPT)) &&              \
138           { echo '$(ME): found use of "file''system";'                  \
139             'rewrite to use "file system"' 1>&2;                        \
140             exit 1; } || :
142 sc_no_have_config_h:
143         @grep -n 'HAVE''_CONFIG_H' $$($(CVS_LIST_EXCEPT)) &&            \
144           { echo '$(ME): found use of HAVE''_CONFIG_H; remove'          \
145                 1>&2; exit 1; } || :
147 # Nearly all .c files must include <config.h>.
148 sc_require_config_h:
149         @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then         \
150           grep -L '^# *include <config\.h>'                             \
151                 $$($(CVS_LIST_EXCEPT) | grep '\.c$$')                   \
152               | grep . &&                                               \
153           { echo '$(ME): the above files do not include <config.h>'     \
154                 1>&2; exit 1; } || :;                                   \
155         else :;                                                         \
156         fi
158 # Prohibit the inclusion of assert.h without an actual use of assert.
159 sc_prohibit_assert_without_use:
160         @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then         \
161           files=$$(grep -l '# *include <assert\.h>'                     \
162                     $$($(CVS_LIST_EXCEPT) | grep '\.c$$')) &&           \
163           grep -L '\<assert (' $$files                                  \
164               | grep . &&                                               \
165             { echo "$(ME): the above files include <assert.h> but don't use it" \
166                   1>&2; exit 1; } || :;                                 \
167         else :;                                                         \
168         fi
170 sc_obsolete_symbols:
171         @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
172              $$($(CVS_LIST_EXCEPT)) &&                                  \
173           { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY'       \
174                 1>&2; exit 1; } || :
176 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
178 # Each nonempty line must start with a year number, or a TAB.
179 sc_changelog:
180         @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) &&    \
181           { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2;  \
182             exit 1; } || :
184 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
185 # with the strings from the two affected variables.
186 dd_c = $(srcdir)/src/dd.c
187 sc_dd_max_sym_length:
188 ifneq ($(wildcard $(dd_c)),)
189         @len=$$( (sed -n '/conversions\[\] =$$/,/^};/p' $(dd_c);\
190                  sed -n '/flags\[\] =$$/,/^};/p' $(dd_c) )      \
191                 |sed -n '/"/s/^[^"]*"\([^"]*\)".*/\1/p'         \
192               | wc --max-line-length);                          \
193         max=$$(sed -n '/^#define LONGEST_SYMBOL /s///p' $(dd_c) \
194               |tr -d '"' | wc --max-line-length);               \
195         if test "$$len" = "$$max"; then :; else                 \
196           echo 'dd.c: LONGEST_SYMBOL is not longest' 1>&2;      \
197           exit 1;                                               \
198         fi
199 endif
201 # Many m4 macros names once began with `jm_'.
202 # On 2004-04-13, they were all changed to start with gl_ instead.
203 # Make sure that none are inadvertently reintroduced.
204 sc_prohibit_jm_in_m4:
205         @grep -nE 'jm_[A-Z]'                                    \
206                 $$($(CVS_LIST) m4 |grep '\.m4$$'; echo /dev/null) && \
207             { echo '$(ME): do not use jm_ in m4 macro names'    \
208               1>&2; exit 1; } || :
210 sc_root_tests:
211         @t1=sc-root.expected; t2=sc-root.actual;                        \
212         grep -nl '^PRIV_CHECK_ARG=require-root'                         \
213           $$($(CVS_LIST) tests) |sed s,tests,., |sort > $$t1;           \
214         sed -n 's,      cd \([^ ]*\) .*MAKE..check TESTS=\(.*\),./\1/\2,p' \
215           $(srcdir)/tests/Makefile.am |sort > $$t2;                     \
216         diff -u $$t1 $$t2 || diff=1;                                    \
217         rm -f $$t1 $$t2;                                                \
218         test "$$diff"                                                   \
219           && { echo 'tests/Makefile.am: missing check-root action'>&2;  \
220                exit 1; } || :
222 headers_with_interesting_macro_defs = \
223   exit.h        \
224   fcntl_.h      \
225   fnmatch_.h    \
226   intprops.h    \
227   inttypes_.h   \
228   lchown.h      \
229   openat.h      \
230   stat-macros.h \
231   stdint_.h
233 # Create a list of regular expressions matching the names
234 # of macros that are guaranteed by parts of gnulib to be defined.
235 .re-defmac:
236         @(cd $(srcdir)/lib;                                             \
237           for f in $(headers_with_interesting_macro_defs); do           \
238             test -f $$f &&                                              \
239               sed -n '/^# *define \([^_ (][^ (]*\)[ (].*/s//\1/p' $$f;  \
240            done;                                                        \
241          ) | sort -u                                                    \
242            | grep -Ev 'ATTRIBUTE_NORETURN|SIZE_MAX'                     \
243            | sed 's/^/^# *define /'                                     \
244           > $@-t
245         @mv $@-t $@
247 # Don't define macros that we already get from gnulib header files.
248 sc_always_defined_macros: .re-defmac
249         @if test -f $(srcdir)/src/system.h; then                        \
250           trap 'rc=$$?; rm -f .re-defmac; exit $$rc' 0 1 2 3 15;        \
251           grep -f .re-defmac $$($(CVS_LIST))                            \
252             && { echo '$(ME): define the above via some gnulib .h file' \
253                   1>&2;  exit 1; } || :;                                \
254         fi
256 # Create a list of regular expressions matching the names
257 # of files included from system.h.  Exclude a couple.
258 .re-list:
259         @sed -n '/^# *include /s///p' $(srcdir)/src/system.h \
260           | grep -Ev 'sys/(param|file)\.h' \
261           | sed 's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
262           > $@-t
263         @mv $@-t $@
265 # Files in src/ should not include directly any of
266 # the headers already included via system.h.
267 sc_system_h_headers: .re-list
268         @if test -f $(srcdir)/src/system.h; then                        \
269           trap 'rc=$$?; rm -f .re-list; exit $$rc' 0 1 2 3 15;          \
270           grep -nE -f .re-list                                          \
271               $$($(CVS_LIST) src |                                      \
272                  grep -Ev '((copy|system)\.h|parse-gram\.c)$$')         \
273             && { echo '$(ME): the above are already included via system.h'\
274                   1>&2;  exit 1; } || :;                                \
275         fi
277 sc_sun_os_names:
278         @grep -nEi \
279             'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
280             $$($(CVS_LIST_EXCEPT)) &&                                   \
281           { echo '$(ME): found misuse of Sun OS version numbers' 1>&2;  \
282             exit 1; } || :
284 sc_the_the:
285         @grep -ni '\<the ''the\>' $$($(CVS_LIST_EXCEPT)) &&             \
286           { echo '$(ME): found use of "the ''the";' 1>&2;               \
287             exit 1; } || :
289 sc_tight_scope:
290         $(MAKE) -C src $@
292 sc_trailing_blank:
293         @grep -n '[      ]$$' $$($(CVS_LIST_EXCEPT)) &&                 \
294           { echo '$(ME): found trailing blank(s)'                       \
295                 1>&2; exit 1; } || :
297 # Match lines like the following, but where there is only one space
298 # between the options and the description:
299 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
300 longopt_re = --[a-z][0-9A-Za-z-]*(\[=[0-9A-Za-z-]*\])?
301 sc_two_space_separator_in_usage:
302         @grep -nE '^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
303             $$($(CVS_LIST_EXCEPT)) &&                                   \
304           { echo "$(ME): help2man requires at least two spaces between"; \
305             echo "$(ME): an option and its description"; \
306                 1>&2; exit 1; } || :
308 # Look for diagnostics that aren't marked for translation.
309 # This won't find any for which error's format string is on a separate line.
310 sc_unmarked_diagnostics:
311         @grep -nE                                                       \
312             '\<error \([^"]*"[^"]*[a-z]{3}' $$($(CVS_LIST_EXCEPT))      \
313           | grep -v '_''(' &&                                           \
314           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
315             exit 1; } || :
317 # Avoid useless parentheses like those in this example:
318 # #if defined (SYMBOL) || defined (SYM2)
319 sc_useless_cpp_parens:
320         @grep -n '^# *if .*defined *(' $$($(CVS_LIST_EXCEPT)) &&        \
321           { echo '$(ME): found useless parentheses in cpp directive'    \
322                 1>&2; exit 1; } || :
324 # Ensure that the c99-to-c89 patch applies cleanly.
325 patch-check:
326         rm -rf src-c89 $@.1 $@.2
327         cp -a src src-c89
328         (cd src-c89; patch -V never --fuzz=0) < src/c99-to-c89.diff \
329           > $@.1 2>&1
330         grep -v '^patching file ' $@.1 > $@.2 || :
331         fail=0; test -s $@.2 && fail=1 || : ; \
332         rm -rf src-c89 $@.1 $@.2; \
333         test $$fail = 0
335 # Ensure that date's --help output stays in sync with the info
336 # documentation for GNU strftime.  The only exception is %N,
337 # which date accepts but GNU strftime does not.
338 extract_char = sed 's/^[^%][^%]*%\(.\).*/\1/'
339 strftime-check:
340         if test -f $(srcdir)/src/date.c; then                           \
341           grep '^  %.  ' $(srcdir)/src/date.c | sort                    \
342             | $(extract_char) > $@-src;                                 \
343           { echo N;                                                     \
344             info libc date calendar format | grep '^    `%.'\'          \
345               | $(extract_char); } | sort > $@-info;                    \
346           diff -u $@-src $@-info || exit 1;                             \
347           rm -f $@-src $@-info;                                         \
348         fi
350 check-AUTHORS:
351         $(MAKE) -C src $@
353 # Ensure that we use only the standard $(VAR) notation,
354 # not @...@ in Makefile.am, now that we can rely on automake
355 # to emit a definition for each substituted variable.
356 makefile-check:
357         grep -nE '@[A-Z_0-9]+@' `find . -name Makefile.am` \
358           && { echo 'Makefile.maint: use $$(...), not @...@' 1>&2; exit 1; } || :
360 news-date-check: NEWS
361         today=`date +%Y-%m-%d`; \
362         if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')' \
363             >/dev/null; then \
364           :; \
365         else \
366           echo "version or today's date is not in NEWS" 1>&2; \
367           exit 1; \
368         fi
370 changelog-check:
371         if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$' \
372             >/dev/null; then \
373           :; \
374         else \
375           echo "$(VERSION) not in ChangeLog" 1>&2; \
376           exit 1; \
377         fi
379 m4-check:
380         @grep -n 'AC_DEFUN([^[]' m4/*.m4 \
381           && { echo 'Makefile.maint: quote the first arg to AC_DEFUN' 1>&2; \
382                exit 1; } || :
384 # Verify that all source files using _() are listed in po/POTFILES.in.
385 # FIXME: don't hard-code file names below; use a more general mechanism.
386 po-check:
387         if test -f po/POTFILES.in; then                                 \
388           grep -E -v '^(#|$$)' po/POTFILES.in                           \
389             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
390           files=;                                                       \
391           for file in $$($(CVS_LIST_EXCEPT)) lib/*.[ch]; do             \
392             case $$file in                                              \
393             djgpp/* | man/*) continue;;                                 \
394             esac;                                                       \
395             case $$file in                                              \
396             *.[ch])                                                     \
397               base=`expr " $$file" : ' \(.*\)\..'`;                     \
398               { test -f $$base.l || test -f $$base.y; } && continue;;   \
399             esac;                                                       \
400             files="$$files $$file";                                     \
401           done;                                                         \
402           grep -E -l '\bN?_\([^)"]*("|$$)' $$files | sort -u > $@-2;    \
403           diff -u $@-1 $@-2 || exit 1;                                  \
404           rm -f $@-1 $@-2;                                              \
405         fi
407 # In a definition of #define AUTHORS "... and ..." where the RHS contains
408 # the English word `and', the string must be marked with `N_ (...)' so that
409 # gettext recognizes it as a string requiring translation.
410 author_mark_check:
411         @grep -n '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
412           { echo 'Makefile.maint: enclose the above strings in N_ (...)' 1>&2; \
413             exit 1; } || :
415 # Sometimes it is useful to change the PATH environment variable
416 # in Makefiles.  When doing so, it's better not to use the Unix-centric
417 # path separator of `:', but rather the automake-provided `@PATH_SEPARATOR@'.
418 # It'd be better to use `find -print0 ...|xargs -0 ...', but less portable,
419 # and there probably aren't many projects with so many Makefile.am files
420 # that we'd have to worry about limits on command line length.
421 msg = 'Makefile.maint: Do not use `:'\'' above; use @PATH_SEPARATOR@ instead'
422 makefile_path_separator_check:
423         @grep -n 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
424           && { echo $(msg) 1>&2; exit 1; } || :
426 # Check that `make alpha' will not fail at the end of the process.
427 writable-files:
428         if test -d $(release_archive_dir); then :; else                 \
429           mkdir $(release_archive_dir);                                 \
430         fi
431         for file in $(distdir).tar.gz $(xd-delta)                       \
432                     $(release_archive_dir)/$(distdir).tar.gz            \
433                     $(release_archive_dir)/$(xd-delta); do              \
434           test -e $$file || continue;                                   \
435           test -w $$file                                                \
436             || { echo ERROR: $$file is not writable; fail=1; };         \
437         done;                                                           \
438         test "$$fail" && exit 1 || :
440 v_etc_file = lib/version-etc.c
441 # Make sure that the copyright date in $(v_etc_file) is up to date.
442 copyright-check:
443         @if test -f $(v_etc_file); then \
444           grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
445             >/dev/null \
446           || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
447                exit 1; }; \
448         fi
451 # Sanity checks with the CVS repository.
452 cvs-tag-check:
453         echo $(this-cvs-tag); \
454         if $(CVS) -n log -h README | grep -e $(this-cvs-tag): >/dev/null; then \
455           echo "$(this-cvs-tag) as already been used; not tagging" 1>&2; \
456           exit 1; \
457         else :; fi
459 cvs-diff-check:
460         if $(CVS) diff >cvs-diffs; then                         \
461           rm cvs-diffs;                                         \
462         else                                                    \
463           echo "Some files are locally modified:" 1>&2;         \
464           cat cvs-diffs;                                        \
465           exit 1;                                               \
466         fi
468 cvs-check: cvs-diff-check cvs-tag-check
470 maintainer-distcheck:
471         $(MAKE) distcheck
472         $(MAKE) my-distcheck
475 # Tag before making distribution.  Also, don't make a distribution if
476 # checks fail.  Also, make sure the NEWS file is up-to-date.
477 # FIXME: use dist-hook/my-dist like distcheck-hook/my-distcheck.
478 cvs-dist: $(local-check) cvs-check maintainer-distcheck
479         $(CVS) update po
480         $(CVS) tag -c $(this-cvs-tag)
481         $(MAKE) dist
483 # Use this to make sure we don't run these programs when building
484 # from a virgin tgz file, below.
485 null_AM_MAKEFLAGS = \
486   ACLOCAL=false \
487   AUTOCONF=false \
488   AUTOMAKE=false \
489   AUTOHEADER=false \
490   MAKEINFO=false
492 # Detect format-string/arg-list mismatches that would normally be obscured
493 # by the use of _().  The --disable-nls effectively defines away that macro,
494 # and building with CFLAGS='-Wformat -Werror' causes any format warning to be
495 # treated as a failure.  Also, check for shadowing problems with -Wshadow,
496 # and for pointer arithmetic problems with -Wpointer-arith.
497 # These CFLAGS are pretty strict.  If you build this target, you probably
498 # have to have a recent version of gcc and glibc headers.
499 TMPDIR ?= /tmp
500 t=$(TMPDIR)/$(PACKAGE)/test
501 my-distcheck: $(local-check) $(release_archive_dir)/$(prev-tgz)
502         -rm -rf $(t)
503         mkdir -p $(t)
504         GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
505         cd $(t)/$(distdir)                              \
506           && ./configure --disable-nls                  \
507           && $(MAKE) CFLAGS='-Werror -Wall -Wformat -Wshadow -Wpointer-arith' \
508               AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)'       \
509           && $(MAKE) dvi                                \
510           && $(MAKE) check                              \
511           && $(MAKE) distclean
512         (cd $(t) && mv $(distdir) $(distdir).old        \
513           && $(AMTAR) -zxf - ) < $(distdir).tar.gz
514         diff -ur $(t)/$(distdir).old $(t)/$(distdir)
515         -rm -rf $(t)
516         @echo "========================"; \
517         echo "$(distdir).tar.gz is ready for distribution"; \
518         echo "========================"
520 WGET = wget
521 WGETFLAGS = -C off
523 rel-check:
524         tarz=/tmp/rel-check-tarz-$$$$; \
525         md5_tmp=/tmp/rel-check-md5-$$$$; \
526         set -e; \
527         trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
528         $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
529         echo "$(md5)  -" > $$md5_tmp; \
530         md5sum -c $$md5_tmp < $$tarz
532 prev-tgz = $(PACKAGE)-$(PREV_VERSION).tar.gz
533 xd-delta = $(PACKAGE)-$(PREV_VERSION)-$(VERSION).xdelta
535 rel-files = $(xd-delta) $(DIST_ARCHIVES)
536 announcement: NEWS ChangeLog $(rel-files)
537         @./announce-gen                                                 \
538             --release-type=$(RELEASE_TYPE)                              \
539             --package=$(PACKAGE)                                        \
540             --prev=$(PREV_VERSION)                                      \
541             --curr=$(VERSION)                                           \
542             --release-archive-directory=$(release_archive_dir)          \
543             --gpg-key-id=$(gpg_key_ID)                                  \
544             --news=NEWS                                                 \
545             $(addprefix --url-dir=, $(url_dir_list))                    \
548 ## ---------------- ##
549 ## Updating files.  ##
550 ## ---------------- ##
552 ftp-gnu = ftp://ftp.gnu.org/gnu
553 www-gnu = http://www.gnu.org
555 # Use mv, if you don't have/want move-if-change.
556 move_if_change ?= move-if-change
558 emit_upload_commands:
559         @echo =====================================
560         @echo =====================================
561         @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
562         @echo "    --to $(gnu_rel_host):coreutils \\"
563         @echo "  $(rel-files)"
564         @echo '# send the /tmp/announcement e-mail'
565         @echo =====================================
566         @echo =====================================
568 $(xd-delta): $(release_archive_dir)/$(prev-tgz) $(distdir).tar.gz
569         xdelta delta -9 $^ $@ || :
571 .PHONY: alpha beta major
572 alpha beta major: news-date-check changelog-check $(local-check)
573         test $@ = major                                         \
574           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
575                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
576           || :
577         $(MAKE) cvs-dist
578         $(MAKE) $(xd-delta)
579         $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
580         ln $(rel-files) $(release_archive_dir)
581         chmod a-w $(rel-files)
582         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
583         echo $(VERSION) > $(prev_version_file)
584         $(CVS) ci -m. $(prev_version_file)